from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "Ivy Generator Pro Addon",
    "author" : "CGBlender", 
    "description" : "More free stuff for Blender: https://t.me/BlenderUniverse",
    "blender" : (3, 5, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os
import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
ivy_generator_pro_addon = {}


_item_map = dict()
def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def sna_update_sna_ivy__8A609(self, context):
    sna_updated_prop = self.sna_ivy_
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Ivy Generator.blend') + r'\Collection', filename=sna_updated_prop, link=False)
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]
        else:
            pass

def sna_ivy__enum_items(self, context):
    enum_items = [['IVY Group', 'IVY Group', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'ivy1.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]
class SNA_PT_IVY_GENERATOR_PRO__6756D(bpy.types.Panel):
    bl_label = 'Ivy Generator Pro '
    bl_idname = 'SNA_PT_IVY_GENERATOR_PRO__6756D'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'IVY'
    bl_order = 0
    
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_ivy_', show_labels=False, scale=5.0, scale_popup=5.0)
        col_80009 = layout.column(heading='', align=False)
        col_80009.alert = False
        col_80009.enabled = True
        col_80009.use_property_split = False
        col_80009.use_property_decorate = False
        col_80009.scale_x = 1.0
        col_80009.scale_y = 1.0
        col_80009.alignment = 'Expand'.upper()
        try:
            col_80009.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_2"]', text='ivy branch', icon_value=245, emboss=True)
            col_80009.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_3"]', text='Randomize ', icon_value=245, emboss=True)
            col_80009.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_4"]', text='Selected Object', icon_value=245, emboss=True)
            col_80009.prop(bpy.data.objects['IVY 5'].modifiers['GeometryNodes'], '["Input_6"]', text='ivy branch Out', icon_value=245, emboss=True)
        except:
            pass




def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_ivy_ = bpy.props.EnumProperty(name='IVY ', description='', items=sna_ivy__enum_items, update=sna_update_sna_ivy__8A609)
    
    
    bpy.utils.register_class(SNA_PT_IVY_GENERATOR_PRO__6756D)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_ivy_
    
    
    bpy.utils.unregister_class(SNA_PT_IVY_GENERATOR_PRO__6756D)

